;
;  PROJECT:         Advanced DLL Wrapper
;  FILE:            adw.asm
;  PURPOSE:         main project module: mapping, export walking,
;                   console logging, source generation
;  PROGRAMMER:      90210
;
;
;  2002/06/15 23:20:34 90210
;
;  TODO:
;       - real command line interface
;
;  HISTORY:
;                   15/06/2002: Created
;                   29/06/2002: Added asm wrapper generation code
;                   15/08/2002: Slightly modified wrapper template

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;DEBUG_BUILD  = TRUE
DEBUG_BUILD  = FALSE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MAX_APIS =1000h

.586
.model       flat,STDCALL

extrn         lstrlenA                 : proc
extrn         GetCommandLineA          : proc
extrn         ExitProcess              : proc
;extrn         GetLastError             : proc
extrn         GetModuleHandleA         : proc
extrn         GetProcAddress           : proc
extrn         LoadLibraryA             : proc
extrn         CreateFileA              : proc
extrn         CreateFileMappingA       : proc
extrn         MapViewOfFile            : proc
extrn         MapViewOfFileEx          : proc
extrn         UnmapViewOfFile          : proc
extrn         CloseHandle              : proc
extrn         GetFullPathNameW         : proc
extrn         GlobalAlloc              : proc
extrn         GlobalFree               : proc
extrn         lstrcatA                 : proc

include       incs\mz.inc
include       incs\pe.inc
include       incs\win32api.inc

IMAGE_SIZEOF_NT_HEADERS      EQU   SIZE IMAGE_NT_HEADERS

.data

APINAME_PREFIX equ 'wrapped_'

coolsrc       db        'wrapper.asm',0
cooldef       db        'wrapper.def',0

logo          db        'Advanced DLL Wrapper v0.0001 (x) 90210//HI-TECH on ',??date,' ',??time,0
usage         db        'usage: adw <dll_to_wrap>',0
cantload      db        'ERROR: can''t load module or invalid image',0
cantgetmem    db        'ERROR: can''t allocate memory for stack',0
noexport      db        'ERROR: no export directory in module',0
what          db        'About to analyze: %s',13,10,0
;mydll         db        'kernel32.dll',0
;dlldef        db        'kernel32.def',0

_apistr       db        '%-30s: RVA = %08X',0
_params       db        ', function has %u parameter(s)',0
_total        db        0dh,0ah,'%s: total: %u, couldn''t analyze: %u',0

forwardedapi  db        ' - api is forwarded',0
nocode        db        ' - section is not executable',0
noretthere    db        ' - can''t calculate params',0
multiplerets  db        ' - different rets found',0

;source template
_sourcestart  db        ';generated by ADW v0.0001 (x) 90210//HI-TECH',13,10
              db        '.586',13,10
              db        '.model                  flat,stdcall',13,10
              db        13,10
              db        13,10
sourcestartlen=$-_sourcestart
_library      db        'LIBRARY old%s',13,10,0

_defexports   db        ';generated by ADW v0.0001 (x) 90210//HI-TECH',13,10
              db        'EXPORTS',13,10
defexportslen =$-_defexports
_expdef       db        '     "%s"',9,'  @%u',13,10,0

_expline      db        '         "%s" = ',APINAME_PREFIX,'%s',13,10,0
explinelen    =$-_expline

_externs      db        'extrn         %s : proc',13,10,0
_datastart    db        13,10
              db        '.data',13,10
              db        '              dd        0',13,10
              db        13,10
              db        '.code',13,10
              db        'DllMain       proc      hinstDLL, fdwReason, lpvReserved:dword',13,10
              db        '              mov       eax,1',13,10
              db        '              ret',13,10
              db        'DllMain       endp',13,10
datastartlen  =$-_datastart

_public       db        'publicdll     ',APINAME_PREFIX,'%s',13,10,0

_wrap         db        13,10
              db        APINAME_PREFIX,'%s proc %s',13,10
              db        '              call      %s%s',13,10
              db        '              ret',13,10
              db        APINAME_PREFIX,'%s endp',13,10,0

_unkpar       db        13,10
              db        APINAME_PREFIX,'%s:',13,10
              db        '              lea       eax,%s+2',13,10
              db        '              mov       eax,[eax]',13,10
              db        '              mov       eax,[eax]',13,10
              db        '              jmp       eax',13,10,0

_codeend      db        13,10,'end           DllMain',13,10
codeendlen    =$-_codeend

_arg          db        'arg%X',0
_dword        db        ':dword',0

writeln       macro     offs2write
              call      writeline,offs2write
endm

dummy         dd        0
currapi       dd        0

cantcalc      dd        0
total         dd        0

stack_        dd        ?
exportsize    dd        ?
;strbuff       db        100 dup (?)

API_CODE            =1
API_NO_CODE         =2
API_FORWARDED       =4
API_COULDNT_ANALYZE =8

apidescr      struct
apiname       dd        ?
apiparams     dw        ?
apitype       db        ?
apiordinal    dw        ?
apihint       dw        ?
apidescr      ends

normalizebuffer db 300 dup (?)
argsproto       db 100 dup (?)
argscall        db 100 dup (?)
mydll           db MAX_PATH dup (?)
dlldef          db MAX_PATH dup (?)
exportedapis  apidescr MAX_APIS dup (<>)
.code

include incs\panalyze.inc
include incs\console.inc
GMEM_FIXED=0
GMEM_ZEROINIT=40h
;STACK_SIZE    =100000

start:        cld
              call      init_console
              writeln   <offset logo>

              call      GetCommandLineA
              xchg      eax,esi
_2lodsd:      lodsd
              sub       esi,3
              or        eax,20202020h
              cmp       eax,'exe.'
              jnz       _2lodsd
              add       esi,3
skipspaces:   lodsb
              cmp       al,' '
              jz        skipspaces
              dec       esi
              call      lstrlenA,esi
              or        eax,eax
              jnz       syntax_ok
              writeln   <offset usage>
              call      ExitProcess,0

syntax_ok:    push      esi
              lea       ecx,[eax+1]
              push      ecx
              lea       edi,mydll

              push      edi
              rep       movsb

              lea       edi,argsproto
              call      wsprintfA,edi,offset what
              add       esp,4*3

              pop       ecx
              pop       esi
              lea       edi,dlldef
              rep       movsb

              mov       [edi-5],'fed.'



              writeln   <edi>

;              call      GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,STACK_SIZE
;              or        eax,eax
;              jnz       memallocated
;              writeln   <offset cantgetmem>
;              call      ExitProcess,0

;memallocated: mov       stack_,eax
              mov       currapi,offset exportedapis

              call      MapModule,offset mydll
              or        eax,eax
              jz        baaad
              mov       ebp,eax

              mov       eax,[ebp.MZ_lfanew]
              lea       ebx,[eax+ebp]
              mov       ecx,[ebx.NT_OptionalHeader\
                                .OH_DirectoryEntries\
                                .DE_Export\
                                .DD_Size]
              or        ecx,ecx
              jz        nullexport

              mov       edx,[ebx.NT_OptionalHeader\
                                .OH_DirectoryEntries\
                                .DE_Export\
                                .DD_VirtualAddress]

              add       edx,ebp

              mov       eax,[ebx.NT_OptionalHeader\
                                .OH_DirectoryEntries\
                                .DE_Export\
                                .DD_Size]
              mov       exportsize,eax


              mov       esi,[edx.ED_AddressOfNames]
              add       esi,ebp

              mov       ecx,[edx.ED_NumberOfNames]      ;get number of exported API namez
              xor       edi,edi


nextfunc:     push      ecx
              lodsd
              add       eax,ebp

              push      eax             ;api name

              mov       eax,[edx.ED_AddressOfOrdinals]
              add       eax,ebp
              movzx     eax,word ptr [eax+edi*2]

              pop       ecx
              push      eax
              push      ecx

              mov       ecx,[edx.ED_AddressOfFunctions]
              add       ecx,ebp
              mov       eax,[ecx+eax*4] ;api address
              pop       ecx             ;api name

              pop       edi             ;api ordinal

              pusha

              push      eax
              push      edx

              mov       edx,currapi
              mov       [edx.apiname],ecx
              mov       [edx.apiordinal],di  ;ordinal is word

              lea       edi,text_buff
              call      wsprintfA,edi,offset _apistr,ecx,eax
              add       esp,4*4
              call      write_console,edi,eax

              pop       edx
              pop       eax

              lea       ecx,[eax+ebp]  ;imagebase+rva
              sub       ecx,edx        ;imagebase+rva - (imagebase+export table start)

              cmp       ecx,exportsize
              jb        forwarded
              or        eax,eax
              jz        forwarded

              call      check4code,ebp,eax
              or        ecx,ecx
              jnz       containscode
              writeln   <offset nocode>

              mov       edx,currapi
              or        [edx.apitype],API_NO_CODE

              jmp       _2popa
containscode:

              mov       edx,currapi
              or        [edx.apitype],API_CODE

              inc       total
              add       eax,ebp

              call      analyzeparams,eax,stack_
              lea       ecx,retdata
              mov       eax,[ecx]
              or        eax,eax
              jnz       retfound

              lea       edx,noretthere
writeerr:     writeln   edx

              mov       edx,currapi
              or        [edx.apitype],API_COULDNT_ANALYZE

              inc       cantcalc
              jmp       _2popa

retfound:     lea       edx,multiplerets
              cmp       dword ptr [ecx+4],0
              jnz       writeerr

              cmp       eax,0ffh
              jnz       paramspresent
              xor       eax,eax
paramspresent:shr       eax,2

              lea       edi,text_buff
              push      eax
              call      wsprintfA,edi,offset _params,eax
              add       esp,4*3
              writeln   edi
              pop       eax

              mov       edx,currapi
              mov       [edx.apiparams],ax

              jmp       _2popa
forwarded:    writeln   <offset forwardedapi>

              mov       edx,currapi
              or        [edx.apitype],API_FORWARDED

_2popa:       push      SIZE apidescr
              pop       ecx
              add       currapi,ecx
              mov       edi,currapi
              xor       al,al
              rep       stosb       ;zero next api description structure
                                    ;(bss, but... just in case ;)
              popa

              pop       ecx
              inc       edi
              loop      _2nextfunc
              jmp       ep
_2nextfunc:   jmp       nextfunc


ep:           ;call      GlobalFree,stackmem
              lea       edi,text_buff
              call      wsprintfA,edi,offset _total,offset mydll,total,cantcalc
              add       esp,4*5
              writeln   edi

;now let's generate source for wrapper
;all exported apis have been analyzed; all we have to do is to walk through
;their description structures

              xor       esi,esi
              call      CreateFileA,offset cooldef,\
                                    GENERIC_READ or GENERIC_WRITE,\
                                    FILE_SHARE_READ,\
                                    esi,\
                                    CREATE_ALWAYS,\
                                    esi,\
                                    esi
              mov       ebx,eax

              call      writefile,offset _defexports,defexportslen

              lea       esi,exportedapis
nextpublic1:  cmp       [esi.apiname],0
              jz        stage1clear
              lea       edi,text_buff

              call      normalizeapiname,[esi.apiname]

              call      wsprintfA,edi,offset _expline,[esi.apiname],eax
              add       esp,4*4
              call      writefile,edi,eax
              add       esi,SIZE apidescr
              jmp       nextpublic1

stage1clear:
              call      CloseHandle,ebx

;def has been generated; make source

              xor       esi,esi
              call      CreateFileA,offset coolsrc,\
                                    GENERIC_READ or GENERIC_WRITE,\
                                    FILE_SHARE_READ,\
                                    esi,\
                                    CREATE_ALWAYS,\
                                    esi,\
                                    esi
              mov       ebx,eax

              call      writefile,offset _sourcestart,sourcestartlen

              lea       esi,exportedapis
nextpublic3:  cmp       [esi.apiname],0
              jz        stage3clear
              lea       edi,text_buff

              call      wsprintfA,edi,offset _externs,[esi.apiname]
              add       esp,4*3
              call      writefile,edi,eax
              add       esi,SIZE apidescr
              jmp       nextpublic3

stage3clear:

              lea       esi,exportedapis
nextpublic2:  cmp       [esi.apiname],0
              jz        stage2clear
              lea       edi,text_buff
              call      normalizeapiname,[esi.apiname]
              call      wsprintfA,edi,offset _public,eax
              add       esp,4*3
              call      writefile,edi,eax
              add       esi,SIZE apidescr
              jmp       nextpublic2

stage2clear:

              call      writefile,offset _datastart,datastartlen

              lea       esi,exportedapis
nextpublic4:  cmp       [esi.apiname],0
              jz        stage4clear
              lea       edi,text_buff

              movzx     eax,[esi.apiparams]
              call      buildargstrings,eax
              call      normalizeapiname,[esi.apiname]

              movzx     ecx,[esi.apitype]
              and       ecx,API_COULDNT_ANALYZE or API_FORWARDED or API_NO_CODE
              jz        good_api
              mov       ecx,[esi.apiname]
              call      wsprintfA,edi,offset _unkpar,ecx,ecx
              add       esp,4*4
              jmp       writechunk

good_api:     call      wsprintfA,edi,offset _wrap,eax,offset argsproto,[esi.apiname],offset argscall,eax
              add       esp,4*7
writechunk:   call      writefile,edi,eax
              add       esi,SIZE apidescr
              jmp       nextpublic4

stage4clear:

              call      writefile,offset _codeend,codeendlen

              call      CloseHandle,ebx

;shitty implib sometimes truncates api namez (<name>@xx -> <name>).
;shitty impdef cannot handle '?' in .def.
;so write correct .def for our dll (user will 'implib <libname> <dllname>.def'
;to get valid lib.

              xor       esi,esi
              call      CreateFileA,offset dlldef,\
                                    GENERIC_READ or GENERIC_WRITE,\
                                    FILE_SHARE_READ,\
                                    esi,\
                                    CREATE_ALWAYS,\
                                    esi,\
                                    esi
              mov       ebx,eax

              lea       esi,text_buff
              call      wsprintfA,edi,offset _library,offset mydll

              call      writefile,edi,eax
              call      writefile,offset _defexports,defexportslen

              lea       esi,exportedapis
nextpublic5:  cmp       [esi.apiname],0
              jz        stage5clear
              lea       edi,text_buff

              movzx     eax,[esi.apiordinal]
              call      wsprintfA,edi,offset _expdef,[esi.apiname],eax
              add       esp,4*4
              call      writefile,edi,eax
              add       esi,SIZE apidescr
              jmp       nextpublic5

stage5clear:
              call      CloseHandle,ebx

              call      ExitProcess,0

baaad:        writeln   <offset cantload>
              jmp       ep
nullexport:   writeln   <offset noexport>
              jmp       ep


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  FUNCTION: MapModule
;;                maps disk file and calls MapModuleFromImage
;;
;;  PARAMETERS:
;;    lpLibFileName : module filename
;;
;;  RETURNS:
;;    eax     :   module imagebase; NULL if some error occured
MapModule     proc      lpLibFileName:dword
              uses      ebx,esi,edi

              xor       esi,esi
              call      CreateFileA,lpLibFileName,GENERIC_READ,FILE_SHARE_READ,esi,OPEN_EXISTING,esi,esi
              cmp       eax,-1
              jz        bad_exit
              mov       ebx,eax
              call      CreateFileMappingA,ebx,esi,PAGE_READONLY,esi,esi,esi
              push      eax

              call      CloseHandle,ebx
              pop       ebx
              call      MapViewOfFile,ebx,FILE_MAP_READ,esi,esi,esi
              mov       edi,eax
              or        eax,eax
              jnz       mappedok
              call      CloseHandle,ebx
              jmp       bad_exit

mappedok:
;let's process image
              call      MapModuleFromImage,edi
              push      eax

              call      UnmapViewOfFile,edi
              call      CloseHandle,ebx

              pop       eax
              ret
bad_exit:     xor       eax,eax
              ret
MapModule     endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  FUNCTION: MapModuleFromImage
;;                check for PE header and tries to create mapping
;;                at image preferred imagebase and copies there
;;                headers and sections data at their rvas.
;;
;;  PARAMETERS:
;;    imagestart : raw image
;;
;;  RETURNS:
;;    eax     :   module imagebase; NULL if some error occured
MapModuleFromImage proc imagestart:dword
              uses      ebx,edi,esi
              local     imagebase:dword
              local     imagestart_:dword

              mov       ebx,imagestart
              mov       imagestart_,ebx
              cmp       [ebx.MZ_magic],IMAGE_DOS_SIGNATURE
              jz        itsmz
notpe:        xor       eax,eax
              ret
itsmz:        mov       eax,[ebx.MZ_lfanew]
              add       eax,ebx
              cmp       [eax.NT_Signature],IMAGE_NT_SIGNATURE
              jnz       notpe
itspe:        cmp       [eax.NT_FileHeader.FH_Machine],IMAGE_FILE_MACHINE_I386
              jnz       notpe
              cmp       [eax.NT_OptionalHeader.OH_Magic],IMAGE_NT_OPTIONAL_HDR_MAGIC
              jnz       notpe
              mov       ebx,eax
              mov       ecx,[eax.NT_OptionalHeader.OH_SizeOfImage]
              xor       esi,esi
              lea       edi,[esi-1]

              add       ecx,1000h

              call      CreateFileMappingA,edi,esi,PAGE_READWRITE,esi,ecx,esi;offset svMappingName
              mov       edi,eax
              or        eax,eax
              jz        notpe

              mov       ecx,[ebx.NT_OptionalHeader.OH_ImageBase]
              call      MapViewOfFileEx,eax,FILE_MAP_WRITE,esi,esi,esi,ecx
              or        eax,eax
              jnz       goodibase
              call      MapViewOfFileEx,edi,FILE_MAP_WRITE,esi,esi,esi,esi
goodibase:    mov       imagebase,eax
              call      CloseHandle,edi

;prepare image: copy headers & sections

              mov       ecx,[ebx.NT_OptionalHeader.OH_SizeOfHeaders]
              mov       edi,imagebase
              mov       esi,imagestart_
              rep       movsb

              movzx     ecx,[ebx.NT_FileHeader.FH_NumberOfSections]
              lea       edx,[ebx+IMAGE_SIZEOF_NT_HEADERS]

nextsection:  push      ecx
              mov       esi,imagestart_
              add       esi,[edx.SH_PointerToRawData]
              mov       edi,imagebase
              add       edi,[edx.SH_VirtualAddress]
              mov       ecx,[edx.SH_SizeOfRawData]
              rep       movsb
              add       edx,IMAGE_SIZEOF_SECTION_HEADER
              pop       ecx
              loop      nextsection

              mov       eax,imagebase
              ret
MapModuleFromImage      endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  FUNCTION: check4code
;;                checks if given rva belongs to section that has
;;                IMAGE_SCN_CNT_CODE attribute
;;
;;  PARAMETERS:
;;    ibase   :   module imagebase
;;    rva     :   rva to check
;;
;;  RETURNS:
;;    eax     :   NULL if rva's section isn't executable, TRUE otherwise
check4code    proc      ibase:dword,rva:dword
              uses      eax,ebx,edx,edi

              mov       eax,ibase
              mov       ebx,[eax.MZ_lfanew]
              add       ebx,eax

              movzx     ecx,[ebx.NT_FileHeader.FH_NumberOfSections]
              lea       edx,[ebx+IMAGE_SIZEOF_NT_HEADERS]
              mov       eax,rva

nextsect:     mov       edi,[edx.SH_VirtualAddress]
              cmp       eax,edi
              jb        notthissect
              add       edi,[edx.SH_VirtualSize]
              cmp       eax,edi
              ja        notthissect

;found section that contains given rva, now check if it contains code

              mov       ecx,[edx.SH_Characteristics]
              and       ecx,IMAGE_SCN_CNT_CODE
              jmp       alldone

notthissect:  add       edx,IMAGE_SIZEOF_SECTION_HEADER
              loop      nextsect
;rva section not found, ecx=0

alldone:      ret
check4code    endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

writefile:    push      0
              push      offset dummy
              push      dword ptr [esp+4*4]
              push      dword ptr [esp+4*4]
              push      ebx
              call      WriteFile
              ret       4*2

normalizeapiname:
              push      esi
              push      edi
              mov       esi,[esp+4*3]
              lea       edi,normalizebuffer
              push      edi
nextbyte:     lodsb
              or        al,al
              jz        lastbyte
              cmp       al,'?'
              jnz       skipchange
              mov       al,'_'
skipchange:   stosb
              jmp       nextbyte
lastbyte:     stosb
              pop       eax
              pop       edi
              pop       esi
              ret

buildargstrings:
              push      esi
              push      edi
              push      ebx

              lea       edi,argsproto
              xor       eax,eax
              mov       [edi],eax
              mov       dword ptr argscall,eax

              mov       ebx,[esp+4*4]
              xor       esi,esi

              or        ebx,ebx
              jz        noparams

nextparam:    call      wsprintfA,edi,offset _arg,esi
              add       esp,4*3
              add       esi,4
              add       edi,eax
              push      202ch        ;', '
              pop       eax
              stosd
              sub       edi,2        ;don't forget terminating null
              dec       ebx
              jnz       nextparam

              sub       edi,2
              mov       [edi],ebx

              lea       edi,argscall
              mov       ax,202ch
              stosw
              lea       esi,argsproto

              call      lstrcatA,edi,esi
              call      lstrcatA,esi,offset _dword
noparams:
              pop       ebx
              pop       edi
              pop       esi
              ret
end start
